/*
 * Bat.cpp
 *
 *  Created on: July 31, 2011
 *      Author: Santi
 */

#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include <windows.h>
#endif

#include "math.h"

#include "debug.h"

#include "Bat.h"
#include "KObjectCreator.h"

#include "Knightmare.h"

Bat::Bat(int x,int y,int sfx_volume,GLTManager *GLTM) : KEnemy(x,y,sfx_volume)
{
	int i;

	m_class = bat_symbol;

    m_n_states = 2;
    m_state_animations = new Animation *[2];

    for(i=0;i<m_n_states;i++) m_state_animations[i]=0;

    m_state = 0;
	m_state_cycle = 0;

	Animation *a = new Animation(true);
	a->addFrame(GLTM->get("bat-flying-001"),8);
	a->addFrame(GLTM->get("bat-flying-002"),8);
	m_state_animations[0]=a;

	a = new Animation(false);
	for(int i = 0;i<6;i++) {
		a->addFrame(GLTM->get("enemy_dying_001"),1);
		a->addFrame(GLTM->get("enemy_dying_002"),1);
	}
	for(int i = 0;i<6;i++) {
		a->addFrame(GLTM->get("enemy_dying_002"),1);
		a->addFrame(GLTM->get("enemy_dying_003"),1);
	}
	for(int i = 0;i<6;i++) {
		a->addFrame(GLTM->get("enemy_dying_003"),1);
		a->addFrame(0,1);
	}
	m_state_animations[1]=a;
	
	m_shadow_tile = GLTM->get("standard-shadow");
	m_shadow_offset = 40;
	
}


Bat::~Bat() {
}


bool Bat::cycle(List<VirtualController> *vcl, Knightmare *game, GLTManager *GLTM, SFXManager *SFXM)
{
	if (!KEnemy::cycle(vcl,game,GLTM,SFXM)) return false;

	switch(m_state) {
	case 0: // "sinus waving":
		{
			float mw = game->get_map()->get_width();
			m_y+=1;
			m_x = mw/2 - 20 - sin(m_state_cycle*0.024)*mw*0.35;
			if (m_y>game->get_map_position()+500) return false;
			if (m_health<=0) {
				m_state = 1;
				m_state_cycle = 0;
			}
			m_state_cycle++;
		}
			break;
	case 1: // dying:
			m_shadow_tile = 0;
			m_state_cycle++;
			if (m_state_cycle>36) return false;
			break;
	}
	
	return true;
}


bool Bat::is_a(Symbol *c)
{
    if (c->cmp(bat_symbol))
        return true;

    return KEnemy::is_a(c);
} /* Bat::is_a */


bool Bat::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);

    retval = is_a(s);

    delete s;

    return retval;
} /* Bat::is_a */
